#!/usr/bin/env python

import sys
import os
import os.path
import shutil
import subprocess
import glob
import re
import string
import random

from nacoma.hooks import Change

bps_path = '/opt/synergy/etc/bps/'
if len(os.listdir(bps_path)) == 0:
    sys.exit()  # exit if there no bps

reportable_types = ['host', 'service', 'hostgroup', 'servicegroup']


def id_generator(size=6, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for x in range(size))


def synergy_rule_queue():
    dirname = id_generator()
    return '/opt/synergy/var/queue/%s' % (dirname)
d = ''


def create_work_dir():
    global d
    if not os.path.exists(d):
        dir_created = 0
        while (not dir_created):
            d = synergy_rule_queue()
            if not os.path.exists(d):
                os.makedirs(d)
                dir_created = 1
        os.system("cp %s* %s" % (bps_path, d))  # copy bps for processing


def rule_str(name, obj, type, rep):
    return 'name = \"%s\",\\n%s\\t%sintent = nagios.%s(\"%s\"' % (name, rep, rep, type,  obj)

#---host---------------------------------


def replace_host(old, new):
    os.system("sed -i ':a;N;$!ba;s|%s|%s|g;s|\"%s\&|\"%s\&|g;s| on %s\"| on %s\"|g;s|host_services(\"%s\"|host_services(\"%s\"|g;s|host = \"%s\"|host = \"%s\"|g' %s/*.lua" % (rule_str(old, old, 'host', '*'), rule_str(new, new, 'host', ""), old, new, old, new, old, new, old, new, d))
    return


def delete_materialized_host(host_name):
    search_str = ",\\s*\\t*\\n*materialized\\n*\\s*\\t*=\\n*\\s*\\t*{\\n*\\s*\\t*host\\n*\\s*\\t*=\\n*\\s*\\t*\"%s\"\\n*\\s*\\t*}" % (host_name)
    os.system("sed -i ':a;N;$!ba;s!%s!!g' %s/*.lua" % (search_str, d))
    return

#--------service--------------------------


def service_obj(name):
    return (name.split(';')[0]+'\&'+name.split(';')[1])


def service_name(name):
    return name.split(';')[1]+' on '+name.split(';')[0]


def replace_service(old, new):
    os.system("sed -i ':a;N;$!ba;s!%s!%s!g' %s/*.lua" % (rule_str(service_name(old), service_obj(old), "service", "*"), rule_str(service_name(new), service_obj(new), "service", ""), d))
    return

#---------hostgroup-----------------------


def replace_hg(old, new):
    os.system("sed -i ':a;N;$!ba;s!%s!%s!g' %s/*.lua" % (rule_str(old, old, "host_group", "*"), rule_str(new, new, "host_group", ""), d))
    return

#-------servicegroup----------------------


def replace_sg(old, new):
    os.system("sed -i ':a;N;$!ba;s!%s!%s!g' %s/*.lua" % (rule_str(old, old, "service_group", "*"), rule_str(new, new, "service_group", ""), d))
    return

printed = False
for line in sys.stdin:
    change = Change(line)
    if change.type not in reportable_types:
        continue
    if change.is_renamed():
        if change.type == 'host':
            create_work_dir()
            replace_host(change.oldname, change.newname)
        if change.type == 'service':
            create_work_dir()
            replace_service(change.oldname, change.newname)
            if not printed:
                print('<span style=\"line-height: 20px;margin-left: 42px;font-weight: bold;\">If renamed service was representing business service you have to rename appropriate service process manually!</br></span>')
                printed = True
        if change.type == 'hostgroup':
            create_work_dir()
            replace_hg(change.oldname, change.newname)
        if change.type == 'servicegroup':
            create_work_dir()
            replace_sg(change.oldname, change.newname)
    if change.is_deleted():
        if change.type == 'host':
            create_work_dir()
            delete_materialized_host(change.oldname)
if not os.path.exists(d):
    sys.exit()
os.system("mv %s /opt/synergy/var/spool/ " % (d))
